#[doc = "Register `PLD1IN1` reader"]
pub struct R(crate::R<PLD1IN1_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PLD1IN1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PLD1IN1_SPEC>> for R {
    fn from(reader: crate::R<PLD1IN1_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PLD1IN1` writer"]
pub struct W(crate::W<PLD1IN1_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PLD1IN1_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PLD1IN1_SPEC>> for W {
    fn from(writer: crate::W<PLD1IN1_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `PI_TOP` reader - RAM configuration nibble for TOP UDB port interface configuration"]
pub struct PI_TOP_R(crate::FieldReader<u8, u8>);
impl PI_TOP_R {
    pub(crate) fn new(bits: u8) -> Self {
        PI_TOP_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PI_TOP_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PI_TOP` writer - RAM configuration nibble for TOP UDB port interface configuration"]
pub struct PI_TOP_W<'a> {
    w: &'a mut W,
}
impl<'a> PI_TOP_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x0f) | (value as u16 & 0x0f);
        self.w
    }
}
#[doc = "Field `PI_BOT` reader - RAM configuration nibble for BOTTOM UDB port interface configuration"]
pub struct PI_BOT_R(crate::FieldReader<u8, u8>);
impl PI_BOT_R {
    pub(crate) fn new(bits: u8) -> Self {
        PI_BOT_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PI_BOT_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PI_BOT` writer - RAM configuration nibble for BOTTOM UDB port interface configuration"]
pub struct PI_BOT_W<'a> {
    w: &'a mut W,
}
impl<'a> PI_BOT_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x0f << 4)) | ((value as u16 & 0x0f) << 4);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:3 - RAM configuration nibble for TOP UDB port interface configuration"]
    #[inline(always)]
    pub fn pi_top(&self) -> PI_TOP_R {
        PI_TOP_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 4:7 - RAM configuration nibble for BOTTOM UDB port interface configuration"]
    #[inline(always)]
    pub fn pi_bot(&self) -> PI_BOT_R {
        PI_BOT_R::new(((self.bits >> 4) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Bits 0:3 - RAM configuration nibble for TOP UDB port interface configuration"]
    #[inline(always)]
    pub fn pi_top(&mut self) -> PI_TOP_W {
        PI_TOP_W { w: self }
    }
    #[doc = "Bits 4:7 - RAM configuration nibble for BOTTOM UDB port interface configuration"]
    #[inline(always)]
    pub fn pi_bot(&mut self) -> PI_BOT_W {
        PI_BOT_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "UDB Channel PI Tile Configuration; PLD Input\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pld1in1](index.html) module"]
pub struct PLD1IN1_SPEC;
impl crate::RegisterSpec for PLD1IN1_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [pld1in1::R](R) reader structure"]
impl crate::Readable for PLD1IN1_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pld1in1::W](W) writer structure"]
impl crate::Writable for PLD1IN1_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PLD1IN1 to value 0"]
impl crate::Resettable for PLD1IN1_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
